{+---------------------------------------+}
{|                                       |}
{|         Bugsy Wabbit's URL Label      |}
{|              Freeware                 |}
{|         by Eugene Mayevski            |}
{|                                       |}
{|         http://i.am/Bugsy             |}
{|             Bugsy@i.am                |}
{+---------------------------------------+}

unit BWURLLabel;

interface

{$R URLLabel.RES}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ShellAPI;

const crURLCursor = 1458;

type
  TBWURLLabel = class(TLabel)
  private
    FURI : String;
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner:TComponent); override;
    procedure Click; override;
    procedure GotoURL;
  published
    property URL : String read FURI write FURI;
    property Align;
    property Alignment;
    property AutoSize;
    property Caption;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FocusControl;
    property Font;
    property ParentShowHint;
    property PopupMenu;
    property ShowAccelChar;
    property ShowHint;
    property Transparent;
    property Layout;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

implementation

constructor TBWURLLabel.Create(AOwner:TComponent);
begin
  inherited;
  Font.Style:=Font.Style+[fsUnderline];
  Font.Color:=clBlue;
  Screen.Cursors[crURLCursor] := LoadCursor(HInstance,'URLCURSOR');
  Cursor:=crURLCursor;
  AutoSize:=true;
end;

procedure TBWURLLabel.Click;
begin
  inherited;
  GotoURL;
end;

procedure TBWURLLabel.GotoURL;
Var
  Param : AnsiString;
Begin
  If Enabled then
  Begin
    Param:=FURI;
    ShellExecute(0,'open',PChar(Param),NIL,NIL,SW_SHOWNORMAL);
  end;
end;

end.
